<?php

class MailChimpSignupPage extends Page {

	static $db = array(
		//	@todo:	provide optional dropdown for entering username/password??
		'MCApiKey'			=> 'Varchar(50)',	//	api_key
		'MCListKey'			=> 'Varchar(50)',	//	list_unique_id
		'MCSuccessContent'	=> 'HTMLText'
	);

	static $mc_api_version = '1.2';

	function getCMSFields() {
		$fields = parent::getCMSFields();

		$fields->addFieldsToTab('Root.Content.MailChimpConfig',array(
			new TextField('MCApiKey', _t('MailChimp.MCAPIKEY', 'API Key')),
			new TextField('MCListKey', _t('MailChimp.MCLISTKEY', 'Unique ID for List')),
			new HTMLEditorField('MCSuccessContent', _t('MailChimp.MCSuccessContent', 'Signup Success Content'))
		));

		$this->extend('updateMailChimpCMSFields');

		return $fields;
	}

}


class MailChimpSignupPage_Controller extends Page_Controller {

	function Form() {
		if (Session::get('MailChimp.SUCCESS')) {
			Session::clear('MailChimp.SUCCESS');
			return false;
		}

		$form = new Form($this, 'Form',
			new FieldSet(
				//	@todo:	add language support for these fields!
				new TextField('email', 'Email Address'),
				new TextField('fname', 'First Name'),
				new TextField('lname', 'Last Name')
			),
			new FieldSet(
				new FormAction('SignupAction', 'Sign Up')
			),
			new RequiredFields('email')
		);

		$this->extend('updateMailChimpForm', $form);

		return $form;
	}

	public function mcsuccess() {
		if (Session::get('MailChimp.SUCCESS'))
			$this->Content = $this->MCSuccessContent;

		return $this;
	}

	function SignupAction($raw_data, $form) {
		$data = Convert::raw2sql($raw_data);

		require_once('MCAPI.php');

		$api = new MCAPI("$this->MCApiKey");
		$list_key = $this->MCListKey;
		$mergeVars = array(
			'FNAME'	=> $data['fname'],
			'LNAME'	=> $data['lname']
		);

		$this->extend('updateMailChimpSignupAction', $data, $mergeVars);

		if (true === $api->listSubscribe($list_key, $data['email'], $mergeVars)) {
			//	success!
			Session::set('MailChimp.SUCCESS', true);
			return $this->mcsuccess();
		}
		else {
			//	failure!
			$form->sessionMessage($api->errorMessage, 'warning');
			return $this;
		}
	}

}

